#! /usr/bin/env python
#
#     Copyright (C) 2005 Ronan Keegan
#
#     This code is distributed under the terms and conditions of the
#     CCP4 Program Suite Licence Agreement as a CCP4 Application.
#     A copy of the CCP4 licence can be obtained by writing to the
#     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
#
#
# 
# Script to setup an environment script for MrBUMP if installed in a non-CCP4 folder
# Ronan Keegan 15/12/05

import os
import string
import shutil


class Make_config:

   def __init__(self):
      self.shell=''
      self.mrbump_dir=''
      self.config_file=''
 
   def setShell(self, shell):
      self.shell=shell
       
   def setMRBUMP_Dir(self, directory):
      self.mrbump_dir=directory

   def setConfig_File(self, filename):
      self.config_file=filename
       
   def write_config(self, mrbump_dir):
 
      self.setShell(string.split(os.environ["SHELL"],'/')[-1])
      self.setMRBUMP_Dir(mrbump_dir)
      self.setConfig_File(self.mrbump_dir + '/configure/mrbump.setup')

      if os.access(self.mrbump_dir + '/configure', os.F_OK) == False:
         os.mkdir(self.mrbump_dir + '/configure')

      f=open(self.config_file,'w')

      if self.shell=='bash':
         f.write("export MRBUMP=" + mrbump_dir + "\n")
         f.write("export PATH=$PATH:$MRBUMP/bin\n")
      elif self.shell=='tcsh':
         f.write("setenv MRBUMP " + mrbump_dir + "\n")
         f.write("set path = ( $MRBUMP/bin $path )\n")
      
      f.close()

if __name__ == '__main__':
    
   m=Make_config()
   m.write_config('/home/rmk65/projects/mrbump-ccp4-build/mrbump-0.2')


